net.sf.saxon.lib

## Interface OutputURIResolver

- All Known Implementing Classes:
    StandardOutputResolver

      public interface OutputURIResolver

  This interface defines an OutputURIResolver. This is a counterpart to the JAXP URIResolver, but is used to map the URI of a secondary result document to a Result object which acts as the destination for the new document.
  Author:
    Michael H. Kay

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close(Result result)` Signal completion of the result document.
    `OutputURIResolver` | `newInstance()` Get an instance of this OutputURIResolver class.
    `Result` | `resolve(String href, String base)` Resolve an output URI.

- - ### Method Detail

    - #### newInstance

          OutputURIResolver newInstance()

      Get an instance of this OutputURIResolver class.

      This method is called every time an xsl:result-document instruction is evaluated (with an href attribute). The resolve() and close() methods will be called on the returned instance.

      If the OutputURIResolver is stateless (that is, it retains no information between resolve() and close()), then the same instance can safely be returned each time. For a stateful OutputURIResolver, it must either take care to be thread-safe (handling multiple invocations of xsl:result-document concurrently), or it must return a fresh instance of itself for each call.

    - #### resolve

          Result resolve(String href,
                       String base)
                         throws TransformerException

      Resolve an output URI.
      Parameters:
        `href` - The relative URI of the output document. This corresponds to the href attribute of the xsl:result-document instruction.
        `base` - The base URI that should be used. This is the Base Output URI, typically the URI of the principal output document
      Returns:
        a Result object representing the destination for the XML document. The method can also return null, in which case the standard output URI resolver will be used to create a Result object.

        The systemId property of the returned Result object should normally be the result of resolving href (as a relative URI) against the value of base. This systemId is used to enforce the error conditions in the XSLT specification that disallow writing two result trees to the same destination, or reading from a destination that is written to in the same transformation. Setting the systemId to null, or to a deceptive value, will defeat these error checks (which can sometimes be useful). Equally, setting the systemId to the same value on repeated calls when different href/base arguments are supplied will cause a spurious error.

      Throws:
        `TransformerException` - if any error occurs

    - #### close

          void close(Result result)
                     throws TransformerException

      Signal completion of the result document. This method is called by the system when the result document has been successfully written. It allows the resolver to perform tidy-up actions such as closing output streams, or firing off processes that take this result tree as input. Note that the OutputURIResolver is stateless, so the the original Result object is supplied to identify the document that has been completed.
      Parameters:
        `result` - The result object returned by the previous call of resolve()
      Throws:
        `TransformerException` - if any error occurs

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.